;-----------------------------------------------------------
; TRSDOS Operating System Interface Tester
;-----------------------------------------------------------

.386
.model flat, stdcall
option casemap :none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc
include \masm32\macros\macros.asm

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

include ..\DMK\DMK.asm
include ..\VDI\VDI.asm
include ..\OSI\OSI.asm
include ..\TRSDOS\TRSDOS.asm

PrintError  proto   :DWORD

.code

Main    proc

            local   vdi:DMK
            local   osi:TRSDOS
            local   hFile:HANDLE
            local   DosVersion:DWORD
            local   DiskName[9]:BYTE
            local   DiskDate[9]:BYTE
            local   FileName[9]:BYTE
            local   FileExt[4]:BYTE
            local   FileSize:DWORD
            local   FileYear:DWORD
            local   FileMonth:DWORD
            local   FileDay:DWORD
            local   FileAttr:DWORD
            local   String[80]:BYTE
            local   FindFlag:BYTE
            local   hFPDE:DWORD
            local   pBuffer:DWORD

            mov     vdi.VPTR, offset DMK_VTBL
            mov     osi.VPTR, offset TRSDOS_VTBL

;jmp Open
    ; --- Get argument from command line ---
    
            fn      GetCommandLine
    
@@:         cmp     byte ptr [eax], ' '
            jz      @F
    
            cmp     byte ptr [eax], 0
            jz      @F
    
            inc     eax
            jmp     @B
    
@@:         inc     eax
    
    ; --- Open file ---
    
;Open:       fn      CreateFile, "c:\asm\projects\vdisk\source\trsdos\dp35.dsk", GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL
            fn      CreateFile, eax, GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL
            
            cmp     eax, INVALID_HANDLE_VALUE
            jne     @F

            fn      GetLastError
            fn      PrintError, eax
            jmp     Done

@@:         mov     hFile, eax

            fn      StdOut, "Loading VDI: "
            fn      VDI_Load, addr vdi, hFile
            fn      PrintError, eax

            fn      StdOut, "Loading OSI: "
            fn      OSI_Load, addr osi, addr vdi
            fn      PrintError, eax

            fn      OSI_GetDosVersion, addr osi
            mov     DosVersion, eax

            fn      OSI_GetDiskName, addr osi, addr DiskName, sizeof DiskName
            mov     DiskName[8], 0

            fn      OSI_GetDiskDate, addr osi, addr DiskDate, sizeof DiskDate
            mov     DiskDate[8], 0

            fn      wsprintf, addr String, "DOS Version: %02X, Disk Name: %s, Disk Date: %s%c%c", DosVersion, addr DiskName, addr DiskDate, 0Dh, 0Ah
            fn      StdOut, addr String

            mov     FindFlag, OSI_FINDFIRST

Next:       fn      OSI_FindFiles, addr osi, FindFlag

            or      eax, eax
            jz      @F

            cmp     eax, -1
            je      @F

            mov     hFPDE, eax

            fn      OSI_GetFileName, addr osi, hFPDE, addr FileName, sizeof FileName
            mov     FileName[8], 0

            fn      OSI_GetFileExtension, addr osi, hFPDE, addr FileExt, sizeof FileExt
            mov     FileExt[3], 0

            fn      OSI_GetFileSize, addr osi, hFPDE
            mov     FileSize, eax

            fn      OSI_GetFileDate, addr osi, hFPDE

            movzx   edx, al
            mov     FileDay, edx

            shr     eax, 8
            movzx   edx, al
            mov     FileMonth, edx

            shr     eax, 8
            movzx   edx, ax
            mov     FileYear, edx

            fn      OSI_GetFileAttributes, addr osi, hFPDE
            mov     FileAttr, eax

            fn      wsprintf, addr String, "%s%s %6i %04i-%02i-%02i %04X%c%c", addr FileName, addr FileExt, FileSize, FileYear, FileMonth, FileDay, FileAttr, 0Dh, 0Ah
            fn      StdOut, addr String

            mov     FindFlag, OSI_FINDNEXT
            jmp     Next

@@:         fn      StdOut, "Reading file: "

            fn      OSI_GetFileHandle, addr osi, "RUNCOBOLPAT"

            cmp     eax, 0                                              ; File not found
            jz      UnloadOSI

            cmp     eax, -1                                             ; Error
            jz      UnloadOSI

            mov     hFPDE, eax

            fn      OSI_GetFileSize, addr osi, hFPDE
            mov     FileSize, eax

            fn      GlobalAlloc, GPTR, FileSize
            mov     pBuffer, eax

            fn      OSI_SetFilePointer, addr osi, hFPDE, 0

            fn      OSI_ReadFile, addr osi, hFPDE, pBuffer, FileSize

            fn      PrintError, eax

            fn      GlobalFree, pBuffer

UnloadOSI:  fn      StdOut, "Unloading OSI: "
            fn      OSI_Unload, addr osi
            fn      PrintError, eax

UnloadVDI:  fn      StdOut, "Unloading VDI: "
            fn      VDI_Unload, addr vdi
            fn      PrintError, eax

Close:      fn      CloseHandle, hFile
       
Done:       fn      ExitProcess, 0

Main    endp

;-----------------------------------------------------------
; PrintError
;-----------------------------------------------------------

PrintError  proc    Error:DWORD

            local   Message[1024]:BYTE

            fn      FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, Error, 0, addr Message, sizeof Message, NULL

            or      eax, eax
            jnz     @F

            fn      GetLastError

            fn      wsprintf, addr Message, "Error %u (GetLastError=%i)%c%c", Error, eax, 0Dh, 0Ah
            
@@:         fn      StdOut, addr Message

            ret

PrintError  endp

end Main

