;---------------------------------------------------------------------
; Graphical User Interface             Copyright (C) 2009 Miguel Dutra
;---------------------------------------------------------------------

GUI_Open            proto   :HWND, :UINT, :WPARAM, :LPARAM
GUI_Open_Cmd        proto   :HWND, :UINT, :WPARAM, :LPARAM
GUI_Open_Init       proto   :HWND

;---------------------------------------------------------------------
; GUI_Open                        Interface selection dialog procedure
;---------------------------------------------------------------------
; hWnd:     Window handle
;---------------------------------------------------------------------
; No return
;---------------------------------------------------------------------

GUI_Open    proc    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    ; --- Handle the WM_INITDIALOG message ---
    
            cmp     uMsg, WM_INITDIALOG
            jne     @F

            fn      GUI_Open_Init, hWnd

            mov     eax, TRUE
            jmp     Done
                
    ; --- Handle the WM_CLOSE message ---
    
@@:         cmp     uMsg, WM_CLOSE
            jne     @F

            fn      EndDialog, hWnd, 0

            mov     eax, TRUE
            jmp     Done

    ; --- Handle the WM_COMMAND message ---

@@:         cmp     uMsg, WM_COMMAND
            jne     @F

            fn      GUI_Open_Cmd, hWnd, uMsg, wParam, lParam
            jmp     Done

    ; --- Message not processed ---

@@:         mov     eax, FALSE
            
Done:       ret

GUI_Open    endp

;---------------------------------------------------------------------
; GUI_Open_Cmd                    Interface selection command handling
;---------------------------------------------------------------------
; hWnd:     Window handle
;---------------------------------------------------------------------
; No return
;---------------------------------------------------------------------

GUI_Open_Cmd        proc    hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

            cmp     wParam, IDC_SEL_OPEN
            jne     @F

            fn      GUI_OpenFileFromResDlg, hWnd

            mov     eax, TRUE
            jmp     Done

@@:         cmp     wParam, IDC_SEL_CANCEL
            jne     @F

            fn      EndDialog, hWnd, 0

            mov     eax, TRUE
            jmp     Done

@@:         mov     eax, FALSE
            
Done:       ret

GUI_Open_Cmd        endp

;---------------------------------------------------------------------
; GUI_Open_Init              Interface selection dialog initialization
;---------------------------------------------------------------------
; hWnd:     Window handle
;---------------------------------------------------------------------
; No return
;---------------------------------------------------------------------

GUI_Open_Init       proc    hWnd:HWND

            local   hControl:HWND

    ; --- Init the File Format combo box --- 

            fn      GetDlgItem, hWnd, IDC_SEL_FF
            mov     hControl, eax

            mov     ecx, GUI_SEL_VDI_Count
            mov     edx, offset GUI_SEL_VDI_Array
            
@@:         push    ecx
            push    edx

            fn      SendMessage, hControl, CB_ADDSTRING, 0, (GUI_SEL_VDI PTR [edx]).pName

            pop     edx
            pop     ecx

            add     edx, sizeof GUI_SEL_VDI
            loop    @B

            fn      SendMessage, hControl, CB_SETCURSEL, 0, 0

    ; --- Init the Operating System combo box --- 

            fn      GetDlgItem, hWnd, IDC_SEL_OS
            mov     hControl, eax

            mov     ecx, GUI_SEL_OSI_Count
            mov     edx, offset GUI_SEL_OSI_Array
            
@@:         push    ecx
            push    edx

            fn      SendMessage, hControl, CB_ADDSTRING, 0, (GUI_SEL_OSI PTR [edx]).pName

            pop     edx
            pop     ecx

            add     edx, sizeof GUI_SEL_OSI
            loop    @B

            fn      SendMessage, hControl, CB_SETCURSEL, 0, 0

            ret

GUI_Open_Init       endp
