;-----------------------------------------------------------
; OSI Test Module
;-----------------------------------------------------------

.386
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc                                    ; GetCommandLine, ExitProcess
include \masm32\include\user32.inc                                      ; wsprintf
include \masm32\include\masm32.inc                                      ; MemCopy, StdOut
include \masm32\macros\macros.asm                                       ; fn

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\masm32.lib

include ..\lib\macros.asm
include ..\VDI\VDI.asm
include OSI.asm

.code

PrintError  proto   Error:DWORD

;-----------------------------------------------------------
; Main
;-----------------------------------------------------------

Main    proc

            local   vdi:CVDI
            local   osi:COSI
            local   Buffer[1024]:BYTE

            mov     vdi.VPTR, offset VDI
            mov     osi.VPTR, offset OSI

            mcall   OSI_VTBL, Load, addr osi, addr vdi
            fn      PrintError, eax

            mcall   OSI_VTBL, GetDosVersion, addr osi
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetDiskName, addr osi, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, SetDiskName, addr osi, "DISK"
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetDiskDate, addr osi, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, SetDiskDate, addr osi, "01/01/80"
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Find, addr osi, OSI_FINDFIRST
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetFileName, addr osi, 1234h, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetFileExt, addr osi, 1234h, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetFileSize, addr osi, 1234h
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetFileDate, addr osi, 1234h
            fn      PrintError, eax
            
            mcall   OSI_VTBL, SetFileDate, addr osi, 1234h, 07BC0101h    ; 1980-01-01
            fn      PrintError, eax
            
            mcall   OSI_VTBL, GetFileAttr, addr osi, 1234h
            fn      PrintError, eax
            
            mcall   OSI_VTBL, SetFileAttr, addr osi, 1234h, 00001117h
            fn      PrintError, eax

            mcall   OSI_VTBL, Open, addr osi, "FILE/EXT"
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Create, addr osi, "NEWFILE/EXT", 100
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Seek, addr osi, 1234h, 0
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Read, addr osi, 1234h, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Write, addr osi, 1234h, addr Buffer, sizeof Buffer
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Rename, addr osi, 1234h, "NEW/EXT"
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Delete, addr osi, 1234h
            fn      PrintError, eax
            
            mcall   OSI_VTBL, Unload, addr osi
            fn      PrintError, eax

Done:       fn      ExitProcess, 0

Main    endp

;-----------------------------------------------------------
; PrintError
;-----------------------------------------------------------

PrintError  proc    Error:DWORD

            local   Message[1024]:BYTE

            fn      FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, NULL, Error, 0, addr Message, sizeof Message, NULL

            or      eax, eax
            jnz     @F

            fn      GetLastError

            fn      wsprintf, addr Message, "Error %u (GetLastError=%i)%c%c", Error, eax, 0Dh, 0Ah
            
@@:         fn      StdOut, addr Message

            ret

PrintError  endp

end Main

