;---------------------------------------------------------------------
; _T()
;---------------------------------------------------------------------

_T MACRO Text
    LOCAL szText
    .data
        szText BYTE Text, 0
    .code
    EXITM <offset szText>
ENDM

;---------------------------------------------------------------------
; @ArgRev()
;---------------------------------------------------------------------

@RevArg MACRO arglist:VARARG
    LOCAL txt, arg                                                      ;; Declare txt
    txt TEXTEQU <>                                                      ;; Initialize txt as empty
    FOR arg, <arglist>                                                  ;; For each arg in arglist
        txt CATSTR <arg>, <!,>, txt                                     ;; Concatenate arg + "," + txt
    ENDM
    IF @SizeStr(%txt) GT 0                                              ;; If txt is not empty
        txt SUBSTR txt, 1, @SizeStr(%txt)-1                             ;; Remove the trailing ","
    ENDIF
    txt CATSTR <!<>, txt, <!>>                                          ;; Add "<" and ">"
    EXITM txt                                                           ;; Return txt
ENDM

;---------------------------------------------------------------------
; mpush()
;---------------------------------------------------------------------

mpush MACRO arg:REQ
    LOCAL pos, attr, str                                                ;; Declare local variables
    pos = @InStr(1, arg, <ADDR>) OR @InStr(1, arg, <addr>)              ;; Check whether arg contains "addr"
    IFE pos                                                             ;; If not found (otherwise OPATTR would report an error)
        attr = OPATTR(arg)                                              ;; Get argument attributes
    ELSE
        attr = 0
    ENDIF
    IFIDN @SubStr(arg, 1, 1), <">                                       ;; If first char is "
        .data
            str     db  arg, 0                                          ;; Declare a null-terminated string
        .code
            push    offset str                                          ;; Push a pointer to it
    ELSEIF pos                                                          ;; if arg contains "addr"
        lea     eax, @SubStr(arg, 6)                                    ;; LEA the argument in front of it
        push    eax                                                     ;; Push it
    ELSEIF ((attr AND 16) OR (attr AND 2)) AND TYPE(arg) NE 4           ;; If arg is a registry or memvar and its size is not 4 bytes
        movzx   eax, arg                                                ;; MOVZX it to a 4-byte register
        push    eax                                                     ;; Push it
    ELSE
        push    arg                                                     ;; Push the argument directly
    ENDIF
ENDM

;---------------------------------------------------------------------
; mcall()
;---------------------------------------------------------------------

mcall MACRO vtbl:REQ, fn:REQ, obj:REQ, arglist:VARARG
    LOCAL arg
    % FOR arg:REQ, @RevArg(arglist)                                     ;; For each arg in the reversed arglist
        mpush   arg                                                     ;; Properly push it in the stack
    ENDM
    mpush   obj                                                         ;; Push pointer to the object
    mov     eax, [esp]                                                  ;; Get pointer to the object
    mov     eax, [eax]                                                  ;; Get pointer to the object's vtbl
    call    (vtbl PTR [eax]).fn                                         ;; Call the requested function
ENDM
